import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import soln.DotController_Version2;

import lt05_pkg.DotController_Version1;
import lt05_pkg.BasicFrame;
import lt05_pkg.PolkaDotDataModel;

/**
 * This app is a GUI app. It instantiates a PolkaDotDataModel. It then passed
 * that model to a view that is created via an instance of BasicFrame. This view
 * installs itself as a listener on the model. Last, this app instantiates a
 * DotController_Version1 controller, which listens for user mouse events and
 * modifies the PolkaDotDataModel upon certain events (see the controller API)
 * 
 * 
 * @author mb
 */
public class driverApp {
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new L20RunnableV3());
	}
}

class MyRunnable implements Runnable {
	@Override
	public void run() {
		// this approach makes use of yet a further modification

		// Here, as in L20App1, we specify a data model and pass it to the view.
		PolkaDotDataModel model = new PolkaDotDataModel();
		JFrame view = new BasicFrame(model);

		// We now instantiate a controller. (refer to the API of the controller)
		new DotController_Version1(view, model);
	}
}
