package lt05_pkg;

import java.awt.Color;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JFrame;

/**
 * This class encapsulates a MouseListener that is installed upon a particular
 * JFrame. When a mouse clicked event is detected, this controller changes the
 * PolkaDotDataModel by adding a random polka dot.
 * 
 * 
 * @author mb
 * 
 */
public class DotController_Version1 implements MouseListener,
		MouseMotionListener {

	private PolkaDotDataModel theModel;
	private JFrame theView;

	public DotController_Version1(JFrame view, PolkaDotDataModel model) {
		theModel = model;
		theView = view;

		/**
		 * The components of the view will generate events; these are produced
		 * when the user performs user actions. We want the controller to be
		 * aware of such events so that it can update the model accordingly.
		 * 
		 */
		theView.addMouseListener(this);
		theView.addMouseMotionListener(this);
	}

	/**
	 * This method causes the data model to be changed when a mouse click event
	 * is detected. A polka dot at the click position is added to the data
	 * model. As well, a statement is printed to the console
	 * "Controller is changing the model"
	 * 
	 */
	@Override
	public void mouseClicked(MouseEvent e) {
		System.out.println("Point: " + e.getPoint());
		System.out.println("Closest Dot?: "
				+ theModel.getClosestShape(e.getPoint()));
		PolkaDot d = theModel.getClosestShape(e.getPoint());
		System.out.println("Controller is changing the model");
		d.setTheColor(Color.BLACK);
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mouseDragged(MouseEvent e) {
	}

	@Override
	public void mouseMoved(MouseEvent e) {
		System.out.println("xxxPoint: " + e.getPoint());
	}

}
